package p2;
//@JPLAS test
import static org.junit.Assert.*;
import java.lang.reflect.Method;
import org.junit.Test;

import report.Report;

public class Animal1Test {

	@Test
	public void test() throws NoSuchMethodException, SecurityException {
		//Animal class
		Animal1 animal=new Animal1();
		//the methods in animal class
		Method m1=animal.getClass().getDeclaredMethod("eat",(Class[])null);
		assertEquals(m1.getReturnType(),String.class);
		//number of methods in Animal class
		Method[] ma=animal.getClass().getDeclaredMethods();
		assertEquals(1, ma.length);
		
		//Dog class
		Dog1 dog=new Dog1();
		//the methods in parent class
		Class<?> DparentClass = dog.getClass().getSuperclass();
		Method m2=DparentClass.getDeclaredMethod("eat", (Class[])null);
		
	    //the method in dog class
		Method m3=dog.getClass().getDeclaredMethod("bark", (Class[])null);
		assertEquals(m3.getReturnType(),String.class);
		
		//number of methods 
		Method[] md=dog.getClass().getDeclaredMethods();
		assertEquals(1, md.length);
		
		//BabyDog class
		BabyDog bd=new BabyDog();
		//the method in parent class
		Class<?> BparentClass = bd.getClass().getSuperclass();
		Method m4=BparentClass.getDeclaredMethod("bark", (Class[])null);
		
		//the method in babydog class
		Method m5=bd.getClass().getDeclaredMethod("weep", (Class[])null);
		assertEquals(m5.getReturnType(),String.class);
		//number of methods in BabyDog class
		Method[] mb=dog.getClass().getDeclaredMethods();
		assertEquals(1, mb.length);	
	}
	
	@Test
	public void test1(){	
	//check the behaviors of methods in each class
		BabyDog d=new BabyDog();
		String weep=d.weep();
		assertEquals("weeping...",weep);
		String bark=d.bark(); 
		assertEquals("barking...",bark);
		String eat=d.eat(); 
		assertEquals("eating...",eat);
	}
	
	@Test
	public void jplasStocker() {
		Report.record(this.getClass().getName());
		
	}
}

